#include "private.h"
#include "xtc_rsrc.h"


Arg args[MAX_ARGLIST_SIZE];
Cardinal args_count;

static Arg onearg;


Dimension
XTCgetResourceDimension (w, rsrc_name)
Widget w;
char *rsrc_name;
{
   Dimension dim;
   onearg.name = rsrc_name;
   onearg.value = (XtArgVal) &dim;
   XtGetValues (w, &onearg, 1);
   return dim;
}


unsigned char
XTCgetResourceUChar (w, rsrc_name)
Widget w;
char *rsrc_name;
{
   unsigned char uc;
   onearg.name = rsrc_name;
   onearg.value = (XtArgVal) &uc;
   XtGetValues (w, &onearg, 1);
   return uc;
}


XtArgVal
XTCgetResourceValue (w, rsrc_name)
Widget w;
char *rsrc_name;
{
   onearg.name = rsrc_name;
   onearg.value = (XtArgVal)(&onearg.value);
   XtGetValues (w, &onearg, 1);
   return onearg.value;
}


char *
XTCgetResourceString (w, rsrc_name)
Widget w;
char *rsrc_name;
{
   XmString temp;
   char *result;

   temp = (XmString) XTCgetResourceValue (w, rsrc_name);
   if (FALSE == XmStringGetLtoR (temp, XmSTRING_DEFAULT_CHARSET, &result))
      result = NULL;
   XmStringFree (temp);
   return result;
}


XmString
XTCmakeMotifString (str)
char *str;
{
   return
     XmStringCreateLtoR (str, XmSTRING_DEFAULT_CHARSET);
}


char *
XTCinterpretMotifString (str)
XmString str;
{
   char *result;
   if (FALSE == XmStringGetLtoR (str, XmSTRING_DEFAULT_CHARSET, &result))
      result = NULL;
   return result;
}


void
XTCsetResourceValue (w, rsrc_name, value)
Widget w;
char *rsrc_name;
XtArgVal value;
{
   onearg.name = rsrc_name;
   onearg.value = value;
   XtSetValues (w, &onearg, 1);
}



void
XTCsetResourceString (w, rsrc_name, value)
Widget w;
char *rsrc_name;
char *value;
{
   onearg.name = rsrc_name;
   onearg.value = (XtArgVal) XTCmakeMotifString(value);
   XtSetValues (w, &onearg, 1);
   XmStringFree ((XmString)(onearg.value));
}



Pixel 
XTCqueryPixel (spec, w)
char *spec;
Widget w;
{
  Colormap cmap;
  XColor color_struct;
  Display  *dpy;

  dpy = XtDisplay(w);  

  cmap = XDefaultColormap(dpy, DefaultScreen(dpy));

  if (!XParseColor(dpy, cmap, spec, &color_struct)) {
     printf("Invalid color name: %s\n", spec);
     exit(1);
  }

  if (!XAllocColor(dpy, cmap, &color_struct)) {
      printf("Cannot allocate color %s in colormap\n", spec);
      exit(1);
   }

  return (color_struct.pixel);
}
